    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------------
    028     * SeriesRenderingOrder.java
    029     * --------------------------
    030     * (C) Copyright 2005-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  Eric Thomas (www.isti.com);
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * Changes:
    036     * --------
    037     * 21-Apr-2005 : Version 1 contributed by Eric Thomas (ET);
    038     * 21-Nov-2007 : Implemented hashCode() (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.plot;
    043
    044    import java.io.ObjectStreamException;
    045    import java.io.Serializable;
    046
    047    /**
    048     * Defines the tokens that indicate the rendering order for series in a
    049     * {@link org.jfree.chart.plot.XYPlot}.
    050     */
    051    public final class SeriesRenderingOrder implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = 209336477448807735L;
    055
    056        /**
    057         * Render series in the order 0, 1, 2, ..., N-1, where N is the number
    058         * of series.
    059         */
    060        public static final SeriesRenderingOrder FORWARD
    061                = new SeriesRenderingOrder("SeriesRenderingOrder.FORWARD");
    062
    063        /**
    064         * Render series in the order N-1, N-2, ..., 2, 1, 0, where N is the
    065         * number of series.
    066         */
    067        public static final SeriesRenderingOrder REVERSE
    068                = new SeriesRenderingOrder("SeriesRenderingOrder.REVERSE");
    069
    070        /** The name. */
    071        private String name;
    072
    073        /**
    074         * Private constructor.
    075         *
    076         * @param name  the name.
    077         */
    078        private SeriesRenderingOrder(String name) {
    079            this.name = name;
    080        }
    081
    082        /**
    083         * Returns a string representing the object.
    084         *
    085         * @return The string (never <code>null</code>).
    086         */
    087        public String toString() {
    088            return this.name;
    089        }
    090
    091        /**
    092         * Returns <code>true</code> if this object is equal to the specified
    093         * object, and <code>false</code> otherwise.
    094         *
    095         * @param obj  the object (<code>null</code> permitted).
    096         *
    097         * @return A boolean.
    098         */
    099        public boolean equals(Object obj) {
    100            if (this == obj) {
    101                return true;
    102            }
    103            if (!(obj instanceof SeriesRenderingOrder)) {
    104                return false;
    105            }
    106            SeriesRenderingOrder order = (SeriesRenderingOrder) obj;
    107            if (!this.name.equals(order.toString())) {
    108                return false;
    109            }
    110            return true;
    111        }
    112
    113        /**
    114         * Returns a hash code for this instance.
    115         *
    116         * @return A hash code.
    117         */
    118        public int hashCode() {
    119            return this.name.hashCode();
    120        }
    121
    122        /**
    123         * Ensures that serialization returns the unique instances.
    124         *
    125         * @return The object.
    126         *
    127         * @throws ObjectStreamException if there is a problem.
    128         */
    129        private Object readResolve() throws ObjectStreamException {
    130            if (this.equals(SeriesRenderingOrder.FORWARD)) {
    131                return SeriesRenderingOrder.FORWARD;
    132            }
    133            else if (this.equals(SeriesRenderingOrder.REVERSE)) {
    134                return SeriesRenderingOrder.REVERSE;
    135            }
    136            return null;
    137        }
    138
    139    }